/**
 * Normalize the trade gain as a function of mapSize for a default of: size=1024 and distance= 100m
 */
function TradeGainNormalization(mapSize)
{
	return Math.sqrt(1024 / mapSize) / TradeGain(10000, mapSize) * 4;
}

/**
 * Part of the trade gain which depends on the distance, the full gain being TradeGainNormalization * TradeGain.
 */
function TradeGain(distanceSquared, mapSize)
{
	return (5 * distanceSquared) / (1 + 0.25 * Math.sqrt(distanceSquared) / mapSize); // 50,000 / 1.25 x 0.7
}
